diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/ruleset.c freeciv-patched/server/ruleset.c
--- freeciv-cvs/server/ruleset.c	2003-06-30 12:33:44.000000000 +0100
+++ freeciv-patched/server/ruleset.c	2003-06-30 12:33:10.000000000 +0100
@@ -2760,92 +2971,109 @@
 **************************************************************************/
 static void send_ruleset_governments(struct conn_list *dest)
 {
+  int i;
+
+  for (i = 0; i < game.government_count; ++i) {
+    send_single_government(dest, i);
+  }
+}
+
+/**************************************************************************
+  Send a single government type to the connections - this allows portions
+  of the government ruleset to be resent to the clients as they change
+  during the course of the game.
+**************************************************************************/
+void send_single_government(struct conn_list *dest, int id)
+{
   struct packet_ruleset_government gov;
   struct packet_ruleset_government_ruler_title title;
   struct ruler_title *p_title;
   struct government *g;
-  int i, j;
+  int i;
 
-  for (i = 0; i < game.government_count; i++) {
-    g = &governments[i];
+  g = &governments[id];
 
-    /* send one packet_government */
-    gov.id                 = i;
+  /* send one packet_government */
+  gov.id                 = id;
 
-    gov.required_tech    = g->required_tech;
-    gov.max_rate         = g->max_rate;
-    gov.civil_war        = g->civil_war;
-    gov.martial_law_max  = g->martial_law_max;
-    gov.martial_law_per  = g->martial_law_per;
-    gov.empire_size_mod  = g->empire_size_mod;
-    gov.empire_size_inc  = g->empire_size_inc;
-    gov.rapture_size     = g->rapture_size;
-    
-    gov.unit_happy_cost_factor  = g->unit_happy_cost_factor;
-    gov.unit_shield_cost_factor = g->unit_shield_cost_factor;
-    gov.unit_food_cost_factor   = g->unit_food_cost_factor;
-    gov.unit_gold_cost_factor   = g->unit_gold_cost_factor;
-    
-    gov.free_happy  = g->free_happy;
-    gov.free_shield = g->free_shield;
-    gov.free_food   = g->free_food;
-    gov.free_gold   = g->free_gold;
-
-    gov.trade_before_penalty = g->trade_before_penalty;
-    gov.shields_before_penalty = g->shields_before_penalty;
-    gov.food_before_penalty = g->food_before_penalty;
-
-    gov.celeb_trade_before_penalty = g->celeb_trade_before_penalty;
-    gov.celeb_shields_before_penalty = g->celeb_shields_before_penalty;
-    gov.celeb_food_before_penalty = g->celeb_food_before_penalty;
-
-    gov.trade_bonus = g->trade_bonus;
-    gov.shield_bonus = g->shield_bonus;
-    gov.food_bonus = g->food_bonus;
-
-    gov.celeb_trade_bonus = g->celeb_trade_bonus;
-    gov.celeb_shield_bonus = g->celeb_shield_bonus;
-    gov.celeb_food_bonus = g->celeb_food_bonus;
-
-    gov.corruption_level = g->corruption_level;
-    gov.corruption_modifier = g->corruption_modifier;
-    gov.fixed_corruption_distance = g->fixed_corruption_distance;
-    gov.corruption_distance_factor = g->corruption_distance_factor;
-    gov.extra_corruption_distance = g->extra_corruption_distance;
-    gov.corruption_max_distance_cap = g->corruption_max_distance_cap;
-    
-    gov.waste_level = g->waste_level;
-    gov.waste_modifier = g->waste_modifier;
-    gov.fixed_waste_distance = g->fixed_waste_distance;
-    gov.waste_distance_factor = g->waste_distance_factor;
-    gov.extra_waste_distance = g->extra_waste_distance;
-    gov.waste_max_distance_cap = g->waste_max_distance_cap;
+  gov.required_tech    = g->required_tech;
+  gov.max_rate         = g->max_rate;
+  gov.civil_war        = g->civil_war;
+  gov.martial_law_max  = g->martial_law_max;
+  gov.martial_law_per  = g->martial_law_per;
+  gov.empire_size_mod  = g->empire_size_mod;
+  gov.empire_size_inc  = g->empire_size_inc;
+  gov.rapture_size     = g->rapture_size;
+
+  gov.basetype         = g->basetype;
+  for (i = 0; i < MAX_MODS; ++i) {
+    gov.modifiers[i]   = g->modifiers[i];
+  }
+    
+  gov.unit_happy_cost_factor  = g->unit_happy_cost_factor;
+  gov.unit_shield_cost_factor = g->unit_shield_cost_factor;
+  gov.unit_food_cost_factor   = g->unit_food_cost_factor;
+  gov.unit_gold_cost_factor   = g->unit_gold_cost_factor;
+    
+  gov.free_happy  = g->free_happy;
+  gov.free_shield = g->free_shield;
+  gov.free_food   = g->free_food;
+  gov.free_gold   = g->free_gold;
+
+  gov.trade_before_penalty = g->trade_before_penalty;
+  gov.shields_before_penalty = g->shields_before_penalty;
+  gov.food_before_penalty = g->food_before_penalty;
+
+  gov.celeb_trade_before_penalty = g->celeb_trade_before_penalty;
+  gov.celeb_shields_before_penalty = g->celeb_shields_before_penalty;
+  gov.celeb_food_before_penalty = g->celeb_food_before_penalty;
+
+  gov.trade_bonus = g->trade_bonus;
+  gov.shield_bonus = g->shield_bonus;
+  gov.food_bonus = g->food_bonus;
+
+  gov.celeb_trade_bonus = g->celeb_trade_bonus;
+  gov.celeb_shield_bonus = g->celeb_shield_bonus;
+  gov.celeb_food_bonus = g->celeb_food_bonus;
+
+  gov.corruption_level = g->corruption_level;
+  gov.corruption_modifier = g->corruption_modifier;
+  gov.fixed_corruption_distance = g->fixed_corruption_distance;
+  gov.corruption_distance_factor = g->corruption_distance_factor;
+  gov.extra_corruption_distance = g->extra_corruption_distance;
+  gov.corruption_max_distance_cap = g->corruption_max_distance_cap;
+    
+  gov.waste_level = g->waste_level;
+  gov.waste_modifier = g->waste_modifier;
+  gov.fixed_waste_distance = g->fixed_waste_distance;
+  gov.waste_distance_factor = g->waste_distance_factor;
+  gov.extra_waste_distance = g->extra_waste_distance;
+  gov.waste_max_distance_cap = g->waste_max_distance_cap;
         
-    gov.flags = g->flags;
-    gov.hints = g->hints;
-    gov.num_ruler_titles = g->num_ruler_titles;
-
-    sz_strlcpy(gov.name, g->name_orig);
-    sz_strlcpy(gov.graphic_str, g->graphic_str);
-    sz_strlcpy(gov.graphic_alt, g->graphic_alt);
+  gov.flags = g->flags;
+  gov.hints = g->hints;
+  gov.num_ruler_titles = g->num_ruler_titles;
+
+  sz_strlcpy(gov.name, g->name_orig);
+  sz_strlcpy(gov.graphic_str, g->graphic_str);
+  sz_strlcpy(gov.graphic_alt, g->graphic_alt);
     
-    gov.effect = g->effect;       /* pointer assignment */
-    gov.helptext = g->helptext;   /* pointer assignment */
+  gov.effect = g->effect;       /* pointer assignment */
+  gov.helptext = g->helptext;   /* pointer assignment */
       
-    lsend_packet_ruleset_government(dest, &gov);
+  lsend_packet_ruleset_government(dest, &gov);
     
-    /* send one packet_government_ruler_title per ruler title */
-    for(j=0; j<g->num_ruler_titles; j++) {
-      p_title = &g->ruler_titles[j];
-
-      title.gov = i;
-      title.id = j;
-      title.nation = p_title->nation;
-      sz_strlcpy(title.male_title, p_title->male_title);
-      sz_strlcpy(title.female_title, p_title->female_title);
+  /* send one packet_government_ruler_title per ruler title */
+  for(i = 0; i < g->num_ruler_titles; i++) {
+    p_title = &g->ruler_titles[i];
+
+    title.gov = id;
+    title.id = i;
+    title.nation = p_title->nation;
+    sz_strlcpy(title.male_title, p_title->male_title);
+    sz_strlcpy(title.female_title, p_title->female_title);
     
-      lsend_packet_ruleset_government_ruler_title(dest, &title);
-    }
+    lsend_packet_ruleset_government_ruler_title(dest, &title);
   }
 }
 
@@ -2995,7 +3223,11 @@
   send_ruleset_game(dest);
   send_ruleset_techs(dest);
   send_ruleset_governments(dest);
+  send_ruleset_gov_modifier_types(dest);
+  send_ruleset_gov_modifiers(dest);
   send_ruleset_units(dest);
+  send_ruleset_unit_modifier_types(dest);
+  send_ruleset_unit_modifiers(dest);
   send_ruleset_terrain(dest);
   send_ruleset_buildings(dest);
   send_ruleset_nations(dest);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/ruleset.h freeciv-patched/server/ruleset.h
--- freeciv-cvs/server/ruleset.h	2003-01-03 16:09:50.000000000 +0000
+++ freeciv-patched/server/ruleset.h	2003-06-30 12:33:10.000000000 +0100
@@ -13,9 +13,14 @@
 #ifndef FC__RULESET_H
 #define FC__RULESET_H
 
+#include "unittype.h"
+
 struct conn_list;
 
 void load_rulesets(void);
 void send_rulesets(struct conn_list *dest);
 
+void send_single_unit(struct conn_list *dest, Unit_Type_id utype_id);
+void send_single_government(struct conn_list *dest, int id);
+
 #endif  /* FC__RULESET_H */
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/savegame.c freeciv-patched/server/savegame.c
--- freeciv-cvs/server/savegame.c	2003-06-30 12:33:44.000000000 +0100
+++ freeciv-patched/server/savegame.c	2003-06-30 12:33:10.000000000 +0100
@@ -24,6 +24,7 @@
 #include "city.h"
 #include "fcintl.h"
 #include "game.h"
+#include "government.h"
 #include "idex.h"
 #include "log.h"
 #include "map.h"
@@ -1813,6 +1814,72 @@
 /***************************************************************
 ...
 ***************************************************************/
+static void govs_load(struct section_file *file)
+{
+  int numcomps, compind, govind;
+
+  numcomps = secfile_lookup_int_default(file, 0, "game.num_compound_govs");
+
+  /* Truncate unit list at the first generated compound gov */
+  for (govind = 0; govind < game.government_count; ++govind) {
+    if (governments[govind].basetype != G_MAGIC) {
+      game.government_count = govind;
+      freelog(LOG_DEBUG, "govs truncated to %d", govind);
+      governments = (struct government *)fc_realloc(governments,
+			game.government_count * sizeof(struct government));
+      break;
+    }
+  }
+  for (compind = 0; compind < numcomps; ++compind) {
+    int modind, modifiers[MAX_MODS];
+    int basetype;
+    char *name;
+
+    name = secfile_lookup_str(file, "game.cgov%d.name", compind);
+    basetype = secfile_lookup_int(file, "game.cgov%d.basetype", compind);
+    for (modind = 0; modind < game.num_gov_modifier_types; ++modind) {
+      modifiers[modind] = secfile_lookup_int(file, "game.cgov%d.modifiers%d",
+	  				     compind, modind);
+    }
+    form_compound_gov(NULL, name, basetype, modifiers);
+  }
+}
+
+/***************************************************************
+...
+***************************************************************/
+static void units_load(struct section_file *file)
+{
+  int numcomps, compind;
+
+  numcomps = secfile_lookup_int_default(file, 0, "game.num_compound_units");
+
+  /* Truncate unit list at the first generated compound unit */
+  unit_type_iterate(uid) {
+    if (unit_types[uid].basetype != U_LAST) {
+      game.num_unit_types = uid;
+      freelog(LOG_DEBUG, "units truncated to %d", uid);
+      break;
+    }
+  } unit_type_iterate_end;
+  for (compind = 0; compind < numcomps; ++compind) {
+    int modind, modifiers[MAX_MODS];
+    Unit_Type_id basetype;
+    char *name;
+
+    name = secfile_lookup_str(file, "game.cunit%d.name", compind);
+    basetype = secfile_lookup_int(file, "game.cunit%d.basetype", compind);
+    for (modind = 0; modind < game.num_unit_modifier_types; ++modind) {
+      modifiers[modind] = secfile_lookup_int(file, "game.cunit%d.modifiers%d",
+	  				     compind, modind);
+    }
+    form_compound_unit(name, basetype, modifiers);
+  }
+}
+
+/***************************************************************
+...
+***************************************************************/
 void game_load(struct section_file *file)
 {
   int i;
@@ -2041,6 +2108,11 @@
     game.cooling=0;
 
     load_rulesets();
+
+    /* This needs to be after rulesets are loaded so that we can access
+     * the base types for generating compound units */
+    units_load(file);
+    govs_load(file);
   }
 
   {
@@ -2229,6 +2301,70 @@
 /***************************************************************
 ...
 ***************************************************************/
+static void govs_save(struct section_file *file)
+{
+  bool write = FALSE;
+  int govind, compind = -1;
+
+  for (govind = 0; govind < game.government_count; ++govind) {
+    struct government *g = &governments[govind];
+
+    if (!write && g->basetype != G_MAGIC) {
+      write = TRUE;
+      secfile_insert_int(file, game.government_count - govind,
+	  		 "game.num_compound_govs");
+    }
+    if (write) {
+      int modind;
+
+      compind++;
+      secfile_insert_str(file, g->name, "game.cgov%d.name", compind);
+      secfile_insert_int(file, g->basetype, "game.cgov%d.basetype",
+	  		 compind);
+      for (modind = 0; modind < game.num_gov_modifier_types; ++modind) {
+	secfile_insert_int(file, g->modifiers[modind],
+	    		   "game.cgov%d.modifiers%d",
+	    		   compind, modind);
+      }
+    }
+  }
+}
+
+/***************************************************************
+...
+***************************************************************/
+static void units_save(struct section_file *file)
+{
+  bool write = FALSE;
+  int compind = -1;
+
+  unit_type_iterate(uid) {
+    struct unit_type *u = &unit_types[uid];
+
+    if (!write && u->basetype != U_LAST) {
+      write = TRUE;
+      secfile_insert_int(file, game.num_unit_types - uid,
+	  		 "game.num_compound_units");
+    }
+    if (write) {
+      int modind;
+
+      compind++;
+      secfile_insert_str(file, u->name, "game.cunit%d.name", compind);
+      secfile_insert_int(file, u->basetype, "game.cunit%d.basetype",
+	  		 compind);
+      for (modind = 0; modind < game.num_unit_modifier_types; ++modind) {
+	secfile_insert_int(file, u->modifiers[modind],
+	    		   "game.cunit%d.modifiers%d",
+	    		   compind, modind);
+      }
+    }
+  } unit_type_iterate_end;
+}
+
+/***************************************************************
+...
+***************************************************************/
 void game_save(struct section_file *file)
 {
   int i;
@@ -2320,6 +2456,9 @@
   secfile_insert_int(file, game.watchtower_extra_vision, "game.watchtower_extra_vision");
   secfile_insert_int(file, game.allowed_city_names, "game.allowed_city_names");
 
+  units_save(file);
+  govs_save(file);
+
   if (TRUE) {
     /* Now always save these, so the server options reflect the
      * actual values used at the start of the game.
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/srv_main.c freeciv-patched/server/srv_main.c
--- freeciv-cvs/server/srv_main.c	2003-06-30 12:33:44.000000000 +0100
+++ freeciv-patched/server/srv_main.c	2003-06-30 12:33:10.000000000 +0100
@@ -833,6 +833,10 @@
     handle_player_tech_goal(pplayer, (struct packet_player_request *)packet);
     break;
 
+  case PACKET_REQUEST_COMPOUND:
+    handle_request_compound(pplayer, (struct packet_request_compound *)packet);
+    break;
+
   case PACKET_UNIT_BUILD_CITY:
     handle_unit_build_city(pplayer, (struct packet_unit_request *)packet);
     break;
